#include <stdio.h>
#include <fcntl.h>
#include <string.h>

#include "g_types.h"

#include "config.h"
#include "urec.h"

int getbytes(FILE *fp, long pos, char *buf, int n)
{
		if(fseek(fp, pos, SEEK_SET))
			return -1;

		return fread(buf, sizeof(char), n, fp);
}

// reads data from USERS.DAT
int load_urec(FILE *fp, struct urec *u, const int32 idx)
{
	// UREC_SIZE * (idx - 1) is the beginning of the record
	long offset = UREC_SIZE * (idx - 1);
	
	char tmp[sizeof(u->handle)];
	
	// +UREC_HO puts us at the handle's offset
	if(getbytes(fp, offset + UREC_HO, tmp, sizeof(tmp)) == -1)
		return 0;
	// convert the pascal string to a C string and copy to u->handle
	strncpy(u->handle, tmp+1, sizeof(u->handle) - 1);
	u->handle[*tmp] = 0;

	// jump to the Calls offset and read the data
	if(getbytes(fp, offset + UREC_CO, (char *) &(u->calls), sizeof(u->calls)) < sizeof(u->calls))
		return 0;

	// same for DLs
	if(getbytes(fp, offset + UREC_DO, (char *) &(u->dl), sizeof(u->dl)) < sizeof(u->dl))
		return 0;

	// and for DLk
	if(getbytes(fp, offset + UREC_DKO, (char *) &(u->dlk), sizeof(u->dlk)) < sizeof(u->dlk))
		return 0;

	// and for ULs
	if(getbytes(fp, offset + UREC_UO, (char *) &(u->ul), sizeof(u->ul)) < sizeof(u->ul))
		return 0;

	// and for ULk
	if(getbytes(fp, offset + UREC_UKO, (char *) &(u->ulk), sizeof(u->ulk)) < sizeof(u->ulk))
		return 0;

	// and for posts
	if(getbytes(fp, offset + UREC_PO, (char *) &u->posts, sizeof(u->posts)) < sizeof(u->posts))
		return 0;

	// and bugger off.
	return 1;
}

